#include <stdio.h>

typedef struct{
	char nimi[50];
	int vanus;
	double palk;
}ISIK;


int failiKontroll(FILE*);
int failiPikkus(FILE*);
void failistSisse(FILE*, ISIK[]);
int keskmineVanus(ISIK[], int);
double keskminePalk(ISIK[], int);
void t66tlus(ISIK[], ISIK[], ISIK[], int, int, double, int[]);
void v2ljastus(ISIK[], ISIK[], ISIK[], int, int, double, int[]);

int main(void){
	FILE *F;
	int pikkus;
	F = fopen("alg.txt", "r");
	if (failiKontroll(F))
		return 1;
	pikkus = failiPikkus(F);
	ISIK isikud[pikkus];
	ISIK isikudVanus[pikkus]; //kelle vanus keskmisest viksem
	ISIK isikudPalk[pikkus];  //kelle palk keskmisest suurem
	failistSisse(F, isikud);
	int kVanus = keskmineVanus(isikud, pikkus);
	double kPalk = keskminePalk(isikud, pikkus);
	int kJada[2];
	t66tlus(isikud, isikudVanus, isikudPalk, pikkus, kVanus, kPalk, kJada);
	v2ljastus(isikud, isikudVanus, isikudPalk, pikkus, kVanus, kPalk, kJada);
	fclose(F);
	return 0;
}

void v2ljastus(ISIK isikud[], ISIK isikudVanus[], ISIK isikudPalk[], int pikkus, int kVanus, double kPalk, int kJada[]){
	int i;
	printf("K6ik isikud:\n");
	for(i=0;i<pikkus;i++){
		printf("%s vanus:%d palk:%.2lf\n", isikud[i].nimi, isikud[i].vanus, isikud[i].palk);
	}
	printf("Vanus keskmisest v2iksem(%d):\n", kVanus);
	for(i=0;i<kJada[0];i++){
		printf("%s vanus:%d palk:%.2lf\n", isikudVanus[i].nimi, isikudVanus[i].vanus, isikudVanus[i].palk);
	}
	printf("Palk keskmisest suurem(%.2lf):\n", kPalk);
	for(i=0;i<kJada[1];i++){
		printf("%s vanus:%d palk:%.2lf\n", isikudPalk[i].nimi, isikudPalk[i].vanus, isikudPalk[i].palk);
	}
}

void t66tlus(ISIK isikud[], ISIK isikudVanus[], ISIK isikudPalk[], int pikkus, int kVanus, double kPalk, int kJada[]){
	int i, iV = 0;
	int iP = 0;
	for(i=0;i<pikkus;i++){
		if (isikud[i].vanus < kVanus){
			isikudVanus[iV] = isikud[i];
			iV++;
		}
		if (isikud[i].palk > kPalk){
			isikudPalk[iP] = isikud[i];
			iP++;
		}
	}
	kJada[0] = iV;
	kJada[1] = iP;
}

int keskmineVanus(ISIK isikud[], int pikkus){
	int k = 0;
	int i;
	for(i=0;i<pikkus;i++){
		k += isikud[i].vanus;
	}
	k /= pikkus;
	return k;
}

double keskminePalk(ISIK isikud[], int pikkus){
	double k = 0;
	int i;
	for(i=0;i<pikkus;i++){
		k += isikud[i].palk;
	}
	k /= pikkus;
	return k;
}

void failistSisse(FILE *F, ISIK isikud[]){
	int i = 0;
	while(fscanf(F, "%s %d %lf", isikud[i].nimi, &isikud[i].vanus, &isikud[i].palk) != EOF){
		i++;
	}
}

int failiKontroll(FILE *F){
	if(F == NULL)
		return 1;
	return 0;
}

int failiPikkus(FILE *F){
	int i=0;
	char buf[256];
	while(fgets(buf, 256, F) != NULL){
		i++;
	}
	rewind(F);
	return i;
}

